> For the complete documentation index, see [llms.txt](https://docs.pascom.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pascom.net/en/integrations/connector/user-csv-import.md).

# Users from CSV-File

Import your users from external systems via CSV

## Connector Profile "Users from CSV"

| Variable                     | Description                                                                                                       |
| ---------------------------- | ----------------------------------------------------------------------------------------------------------------- |
| **Name**                     | Profile name                                                                                                      |
| **Type**                     | <p>Select the import option for the CSV file:<br><em>Default</em>: Upload in Browser<br>Fetch from url</p>        |
| **Encoding of the CSV File** | Select the CSV file format. We recommend using UTF-8.                                                             |
| **Delimiter**                | Select the separating character which separates the CSV fields.                                                   |
| **Line Separator**           | If the CSV file is generated under Windows opposed to Mac / Linux, the line ending will be signified differently. |
| **Field Enclosure**          | We recommend enclosing individual fields inside specific characaters, e.g. "Max Muster"                           |

After saving, the template can be modified according to requirements under the **Basic Data** tab.

### Basic Data

Under Basic Data, you can more exactly configure the CSV import or change your recently configured CSV import settings.

| Field               | Description                                                                                                                                                                                                                                                                                                                                                              |
| ------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| **Title**           | Connector profile name (*Automatically filled*)                                                                                                                                                                                                                                                                                                                          |
| **Source**          | CSV (*cannot be altered*)                                                                                                                                                                                                                                                                                                                                                |
| **Mode**            | <p><strong>Create and update records. Remove missing records from previous imports.</strong>: (<em>default setting</em>) Imports only new phone book entries and compares updated entries, old entries will be removed.<br><strong>Create and update records</strong>: Imports only new phone book entries and compares updated entries. No entries will be removed.</p> |
| **Type**            | <p>If you selected <strong>Upload in Browser</strong> when setting up your template: Upload manually<br>If you selected <strong>Fetch from URL</strong> when setting up your template: Download from URL</p>                                                                                                                                                             |
| **CSV File**        | If you selected "Upload in Browser", the file can be directly uploaded here.                                                                                                                                                                                                                                                                                             |
| **CSV File URL**    | If you selected "Fetch from url", the file path URL can be entered here.                                                                                                                                                                                                                                                                                                 |
| **Delimiter**       | The separating character which separates the CSV fields. (*Automatically filled*)                                                                                                                                                                                                                                                                                        |
| **File Format**     | Specifies the CSV file format. (*Automatically filled*)                                                                                                                                                                                                                                                                                                                  |
| **Line Separator**  | Specifies under which Operating System the CSV file was generated. (*Automatically filled*)                                                                                                                                                                                                                                                                              |
| **Field Enclosure** | Specifies whether and which field enclosures are used in the CSV file. (*Automatically filled*                                                                                                                                                                                                                                                                           |
| **Comments**        | Can be used as a documentation / description box for the connector profile.                                                                                                                                                                                                                                                                                              |

### Pre Filter

Per default, the template will import all lines from the CSV file. Via the **Pre Filter** tab, it is possible to restrict the import to specific values, e.g. the column *displayname* is not empty. In the code, replace "return true" with the following code snippet:

```
    return array_key_exists('displayName', $row);
```

### User Fields from CSV

In the **Variables** tab, all the fields which can be imported into your PASCOM cloud phone system are listed. The field mapping from CSV > PASCOM can also be modified to match your needs under this tab. Per default, the CSV column names correspond to the field names within the PASCOM PBX.

An example for a CSV file:

```
    "displayname","username","password","pin","phone","givenname","surname","email","mobile","homephone","job"
    "Max Muster","mmuster","12ab34cd56","1234","345","Max","Muster","","","","Sales Director"
```

### Test and Activate Import Process

Once you are finished with your configuration, you can test your setup using the **Save and simulate** button and see which data sets will be imported. Once satisfied with the test results, you can now either run the import as a one-off via **Action** > **Import Now** or as an automated regular import using the **Automate** button.

{% hint style="info" %}
An automated import is only recommended for import types **Fetch from URL**.
{% endhint %}

#### Optional Modifications

Do you want to make changes to source variables or the Connector structure? Then follow the links below to the appropriate instructions:

[Variable Assignment](/en/integrations/connector/variables-assignment.md)

[Variables structure](/en/integrations/connector/variables-structure.md)

#### Assign IP-Telephones

It is possible to directly assign IP telephones to users via the CSV import.

If you wish to assign the user a PASCOM softphone, then no further variables need to be added to the PASCOM Connector.

**Assign IP telephone via MAC address:**

In your CSV file, add the columns "phonemac" and "phoneip", in which you can then enter the MAC and IP addresses of the desired IP telephones.

This will automatically assign the imported users with the corresponding IP telephones.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.pascom.net/en/integrations/connector/user-csv-import.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `build a script that syncs our docs to a CMS` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
